/* This file estimates the effect of High School graduation on incarceration probability using Census data merged with compulsory schooling data (INMATES.DTA). 
NOTE: the estimation uses only data for 1980. */
** The coefficient of interest is the one referring to the variable "dropinv". 
set mem 1000m
clear
use inmates.dta, replace
drop  pob gqtype educ work_age work_sch enrolage drop_age cl cl6 cl7 cl8 cl9
gen dropinv=1
replace dropinv=0 if drop==1
gen dage1=age<23
gen dage2=age>22 & age<26
gen dage3=age>25 & age<29
gen dage4=age>28 & age<32
gen dage5=age>31 & age<35
gen dage6=age>34 & age<38
gen dage7=age>37 & age<41
gen dage8=age>40 & age<44
gen dage9=age>43 & age<47
gen dage10=age>46 & age<50
gen dage11=age>49 & age<53
gen dage12=age>52 & age<56
gen dage13=age>55 & age<59
gen dage14=age>58
gen dbirth1=yearat14<1924
gen dbirth2=yearat14>1923 & yearat14<1934
gen dbirth3=yearat14>1933 & yearat14<1944
gen dbirth4=yearat14>1943 & yearat14<1954
gen dbirth5=yearat14>1953 & yearat14<1964
gen dbirth6=yearat14>1963 & yearat14<1974
gen dbirth7=yearat14>1973
gen dyear1=year==60
gen dyear2=year==70
gen dyear3=year==80
tabulate birthpl, gen(dbplace)
tabulate state, gen(dstate)
save inmates-workfile.dta, replace
use inmates-workfile.dta, replace
** IV regression to estimate effect of education (dropout or not) on incarceration 
** (Table 8, "Data" column)

ivregress 2sls prison dage* dbirth* dstate* dbplace*  (dropinv = ca9 ca10 ca11) if year==80
