/* This file estimates the effect of High School graduation on incarceration probability using simulated data. 
NOTE: the data are obtained from the stationary equilibrium calibrated to the year 1980.*/
** The coefficient of interest is the one referring to the variable "hsgrad". 
set mem 1000m
clear
use inmates-simulated.dta, replace
* construct HS graduation dummy 
cap drop hsgrad
gen hsgrad=etracking>1
* construct incarceration dummy
cap drop incarceration
gen incarceration=atracking
replace incarceration=1 if atracking==2
* construct age dummies
cap drop dage*
gen dage1=age<23
gen dage2=age>22 & age<26
gen dage3=age>25 & age<29
gen dage4=age>28 & age<32
gen dage5=age>31 & age<35
gen dage6=age>34 & age<38
gen dage7=age>37 & age<41
gen dage8=age>40 & age<44
gen dage9=age>43 & age<47
gen dage10=age>46 & age<50
gen dage11=age>49 & age<53
gen dage12=age>52 & age<56
gen dage13=age>55 & age<59
gen dage14=age>58
/* This regression estimates the effect of high school graduation on
incarceration using  simulated data (2014) */
/*Variables used to estimate the effect of education on incarceration (Table
8, "Model" column)*/
/* We control explicitly for individual ability and crime fixed effects (utility cost of crime) to identify the pure effect of additional schooling */
reg  incarceration hsgrad dage* i_fixed crim_fixed
